<?php
//подключение к серверу SMTP
$config['smtp_username'] = 'hub@micronlab.com.ua'; //имя своего почтового ящика.
//$config['smtp_username'] = 'healthy044@gmail.com';
$config['smtp_port'] = '2525';
//$config['smtp_port'] = '25';
$config['smtp_host'] = 'mail.ukraine.com.ua'; //сервер для отправки почты
//$config['smtp_host'] = 'ukraine.com';
$config['smtp_password'] = '3e8VlZDHs75u'; // пароль
//$config['smtp_password'] = 'Anton4Promo';

$config['smtp_debug'] = false; //Если Вы хотите видеть сообщения ошибок, укажите true вместо false
$config['smtp_charset'] = 'UTF-8'; //кодировка сообщений. (или UTF-8, итд)
$config['smtp_from'] = 'no-replay@micronlab.com.ua'; //Ваше имя - или имя Вашего сайта. Будет показывать при прочтении в поле "От кого"






//подключение к серверу SMS
$serversms = '94.249.146.189';
$loginsms = 'qclinic';
//$passwordsms = 'Anton4Promo';
$passwordsms = '869919';
$signsms = 'Micron';
$dbsms = 'users';
//$dbs = new mysqli ($serversms,$loginsms,$passwordsms,$dbsms);
//$dbs->query("SET CHARSET SET utf8");
//$dbs->query("SET NAMES 'utf8'");
//if (mysqli_connect_errno()){
//echo "Error connecting to DBSMS";
//exit;
//}

//подключение к принтеру
$url = "http://194.0.150.90:5113/TSCPrinterService/";


//отправка почты
function smtpmail($mail_to, $subject, $message, $headers=''){
        global $config;
        $SEND =   "Date: ".date("D, d M Y H:i:s") . " UT\r\n";
        $SEND .=   'Subject: =?'.$config['smtp_charset'].'?B?'.base64_encode($subject)."=?=\r\n";
        if ($headers) $SEND .= $headers."\r\n\r\n";
        else
        {
                $SEND .= "Reply-To: ".$config['smtp_username']."\r\n";
                $SEND .= "MIME-Version: 1.0\r\n";
                $SEND .= "Content-Type: text/plain; charset=\"".$config['smtp_charset']."\"\r\n";
                $SEND .= "Content-Transfer-Encoding: 8bit\r\n";
                $SEND .= "From: \"".$config['smtp_from']."\" <".$config['smtp_username'].">\r\n";
                $SEND .= "To: $mail_to <$mail_to>\r\n";
                $SEND .= "X-Priority: 3\r\n\r\n";
        }
        $SEND .=  $message."\r\n";
         if( !$socket = fsockopen($config['smtp_host'], $config['smtp_port'], $errno, $errstr, 30) ) {
            if ($config['smtp_debug']) echo $errno."&lt;br&gt;".$errstr;
            return false;
         }

            if (!server_parse($socket, "220", __LINE__)) return false;

            fputs($socket, "HELO " . $config['smtp_host'] . "\r\n");
            if (!server_parse($socket, "250", __LINE__)) {
               if ($config['smtp_debug']) echo '<p>Не могу отправить HELO!</p>';
               fclose($socket);
               return false;
            }
            fputs($socket, "AUTH LOGIN\r\n");
            if (!server_parse($socket, "334", __LINE__)) {
               if ($config['smtp_debug']) echo '<p>Не могу найти ответ на запрос авторизаци.</p>';
               fclose($socket);
               return false;
            }
            fputs($socket, base64_encode($config['smtp_username']) . "\r\n");
            if (!server_parse($socket, "334", __LINE__)) {
               if ($config['smtp_debug']) echo '<p>Логин авторизации не был принят сервером!</p>';
               fclose($socket);
               return false;
            }
            fputs($socket, base64_encode($config['smtp_password']) . "\r\n");
            if (!server_parse($socket, "235", __LINE__)) {
               if ($config['smtp_debug']) echo '<p>Пароль не был принят сервером как верный! Ошибка авторизации!</p>';
               fclose($socket);
               return false;
            }
            fputs($socket, "MAIL FROM: <".$config['smtp_username'].">\r\n");
            if (!server_parse($socket, "250", __LINE__)) {
               if ($config['smtp_debug']) echo '<p>Не могу отправить комманду MAIL FROM: </p>';
               fclose($socket);
               return false;
            }
            fputs($socket, "RCPT TO: <" . $mail_to . ">\r\n");

            if (!server_parse($socket, "250", __LINE__)) {
               if ($config['smtp_debug']) echo '<p>Не могу отправить комманду RCPT TO: </p>';
               fclose($socket);
               return false;
            }
            fputs($socket, "DATA\r\n");

            if (!server_parse($socket, "354", __LINE__)) {
               if ($config['smtp_debug']) echo '<p>Не могу отправить комманду DATA</p>';
               fclose($socket);
               return false;
            }
            fputs($socket, $SEND."\r\n.\r\n");

            if (!server_parse($socket, "250", __LINE__)) {
               if ($config['smtp_debug']) echo '<p>Не смог отправить тело письма. Письмо не было отправленно!</p>';
               fclose($socket);
               return false;
            }
            fputs($socket, "QUIT\r\n");
            fclose($socket);
            return TRUE;
}
function server_parse($socket, $response, $line = __LINE__) {
    global $config;
    while (substr($server_response, 3, 1) != ' ') {
        if (!($server_response = fgets($socket, 256))) {
                   if ($config['smtp_debug']) echo "<p>Проблемы с отправкой почты!</p>$response<br>$line<br>";
                   return false;
                }
    }
    if (!(substr($server_response, 0, 3) == $response)) {
           if ($config['smtp_debug']) echo "<p>Проблемы с отправкой почты!</p>$response<br>$line<br>";
           return false;
        }
    return true;
}

function send_email($subject,$emailTo,$textEmail){
    $headers = "From: \"micronlab.com.ua\" <no-replay@micronlab.com.ua>\r\n".
				"Content-Type: text/html; charset=\"utf-8\"\r\n";
    smtpmail($emailTo,$subject, $textEmail, $headers);
}


//отправка sms
/*function send_sms($phone,$textSms,$logger){
	global $dbs;
	global $loginsms;
	global $signsms;
	$phone = trim($phone);
    $phone = str_replace(array("\n","\r\n","\r"," "), '', $phone);
    $patterns = array ('/^0\d{9}$/', '/^3\d{11}$/', '/^8\d{10}$/');
    $replace = array ('+38'.$phone, '+'.$phone, '+3'.$phone);
    $phone = preg_replace($patterns, $replace, $phone);
	//$logger->WriteLogs('client_id: '.$clientid.'  -- Date: '.date("Y-m-d H:i:s").' -- Type operation: "Send SMS phone" --: '.$phone, 'sms', 'logs');

    if($phone || $phone!=""){
        $query = "INSERT INTO $loginsms (`number`,`sign`,`message`) VALUES ('".$phone."','".$signsms."','".$textSms."');";
        //echo $query;
		//$logger->WriteLogs('client_id: '.$clientid.'  -- Date: '.date("Y-m-d H:i:s").' -- Type operation: "Send SMS query" --: '.$query, 'sms', 'logs');
		if($stmt = $dbs->prepare($query)){
		if($stmt->execute()){
			$stmt->close();
			return 'true';
		}else{ return 'false'; }
		}else{ return 'false'; }
    }
}*/

//отправка sms 2

function send_sms($phone,$textSms,$logger){
	
	global $loginsms;
	global $passwordsms;
	global $signsms;
	
	$phone = trim($phone);
    $phone = str_replace(array("\n","\r\n","\r"," "), '', $phone);
    $patterns = array ('/^0\d{9}$/', '/^3\d{11}$/', '/^8\d{10}$/');
    $replace = array ('+38'.$phone, '+'.$phone, '+3'.$phone);
    $phone = preg_replace($patterns, $replace, $phone);

	//echo $phone;
	
try {  

    // Подключаемся к серверу   
    $client = new SoapClient('http://turbosms.in.ua/api/wsdl.html');     

    // Данные авторизации   
    $auth = array (   
        'login' => $loginsms,   
        'password' => $passwordsms   
    );   

    // Авторизируемся на сервере   
    $result = $client->Auth($auth);   

    // Результат авторизации   
    //echo $result->AuthResult;   

    // Получаем количество доступных кредитов   
    //$result = $client->GetCreditBalance();   
    //echo $result->GetCreditBalanceResult;   

    // Текст сообщения ОБЯЗАТЕЛЬНО отправлять в кодировке UTF-8   
    //$textSms = iconv('windows-1251', 'utf-8', $textSms);   

     
    $sms = array (   
        'sender' => $signsms,   
        'destination' => $phone,   
        'text' => $textSms   
    );  
    $result = $client->SendSMS($sms);
	
	// Выводим результат отправки.   
    //echo $result->SendSMSResult->ResultArray[0];
	
}catch(Exception $e){ 
    //echo 'Ошибка: ' . $e->getMessage();
	return false;
}

}

//получение списка пользователей для рассылки почты и смс
function get_admin_contact($instanceid,$db){
	$query = "SELECT `phone`,`email` FROM `mc_contact` WHERE `instance_id` = ".$instanceid.";";
	//echo $query;
	if(!$stmt = $db->query($query)){
		return $result = array();
	}else{
		for ($result = array(); $tmp = $stmt->fetch_array(MYSQLI_ASSOC);) $result[] = $tmp;
		$stmt->close();
		return $result;
	}
}


//транслит
function GetInTranslit($string) {
	$replace=array(
		"'"=>"",
		"`"=>"",
		"\""=>"",
		"а"=>"a","А"=>"a",
		"б"=>"b","Б"=>"b",
		"в"=>"v","В"=>"v",
		"г"=>"g","Г"=>"g",
		"д"=>"d","Д"=>"d",
		"е"=>"e","Е"=>"e",
		"ж"=>"zh","Ж"=>"zh",
		"з"=>"z","З"=>"z",
		"и"=>"i","И"=>"i",
		"й"=>"y","Й"=>"y",
		"к"=>"k","К"=>"k",
		"л"=>"l","Л"=>"l",
		"м"=>"m","М"=>"m",
		"н"=>"n","Н"=>"n",
		"о"=>"o","О"=>"o",
		"п"=>"p","П"=>"p",
		"р"=>"r","Р"=>"r",
		"с"=>"s","С"=>"s",
		"т"=>"t","Т"=>"t",
		"у"=>"u","У"=>"u",
		"ф"=>"f","Ф"=>"f",
		"х"=>"h","Х"=>"h",
		"ц"=>"c","Ц"=>"c",
		"ч"=>"ch","Ч"=>"ch",
		"ш"=>"sh","Ш"=>"sh",
		"щ"=>"sch","Щ"=>"sch",
		"ъ"=>"","Ъ"=>"",
		"ы"=>"y","Ы"=>"y",
		"ь"=>"","Ь"=>"",
		"э"=>"e","Э"=>"e",
		"ю"=>"yu","Ю"=>"yu",
		"я"=>"ya","Я"=>"ya",
		"і"=>"i","І"=>"i",
		"ї"=>"yi","Ї"=>"yi",
		"є"=>"e","Є"=>"e"
	);
	return $str=iconv("UTF-8","UTF-8//IGNORE",strtr($string,$replace));
}

//печать етикеток
function ApiSharedService($json){
	
	global $url;
	
	try{	
		if( $curl = curl_init() ) {
			curl_setopt($curl, CURLOPT_URL, $url);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER,true);
			curl_setopt($curl, CURLOPT_POST, true);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $json);
			curl_setopt($curl, CURLOPT_NOSIGNAL, 1);
			curl_setopt($curl, CURLOPT_TIMEOUT_MS, 60000);
			$out = curl_exec($curl);
			$curl_errno = curl_errno($curl);
			$curl_error = curl_error($curl);
			curl_close($curl);
			//$json_answer = json_decode($out, true);
			if ($curl_errno > 0) {
				die('ConnectError');
			}else{
				return $out;
			}

		}else{ die('ConnectError'); }
			
	}catch(Exception $e){
		die('ConnectError');
	}
}

?>